% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'rmin'}, {'lower end of the range, scalar'}};
            {{'rmax'}, {'upper end of the range, scalar'}};
            {{'minmax'}, {'range, array of two scalars'}};
            {{'range'}, {'range, array of two scalars, same as minmax'}};
            {{'colormap'}, {'colormap, as an array'}};
            };
%       {{'nconn'}, {'number of individual connectivities in this set'}};
              return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'rmin'
                val = self.rmin;
            case 'rmax'
                val = self.rmax;
            case 'minmax'
                val = [self.rmin,self.rmax];
            case 'range'
                val = [self.rmin,self.rmax];
            case 'colormap'
                val = self.colormap;
            otherwise
                val = get(self.classbase,prop_name);
        end
    end
end
