% Constructor of the element vector set class.
%
% function self = elevecset (varargin)
%
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>. 
% Parameters:
% eqnums= equation numbers, cell array of arrays of equation numbers
% vec = matrix, cell array of elementwise arrays
% 
% Example: self = elevecset (struct('eqnums',eqnums,'vec',vec))
%
function self = elevecset (varargin)
    class_name='elevecset';
    parent=classbase;
    if (nargin == 0)
        self.eqnums =  {};
        self.vec = {};
        self = class(self,class_name,parent);
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            self = arg;
            return;
        else
            Parameters =varargin{1};
            self.eqnums = Parameters.eqnums;
            self.vec = Parameters.vec;
            self = class(self,class_name,parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end


