
%
function E = defor_energy(self, geom, u1, u)
    E=0;
    gcells = get(self.feblock,'gcells');
    ngcells = length(gcells);
    nfens = get(gcells(1),'nfens');
    dim = get(geom,'dim');
     % Integration rule
    integration_rule = get(self.feblock, 'integration_rule');
    pc = get(integration_rule, 'param_coords');
    w  = get(integration_rule, 'weights');
    npts_per_gcell = length(pc); % number of integration point
    % Material
    mat = get(self, 'mater');
    matstates = get(self, 'matstates');
    % Now loop over all gcells in the block
    for i=1:ngcells
        conn = get(gcells(i), 'conn'); % connectivity
        X = gather(geom, conn, 'values', 'noreshape'); % reference coordinates
        U = gather(u, conn, 'values', 'noreshape'); % displacement in step n
        U1 = gather(u1, conn, 'values', 'noreshape'); % displacement in step n+1
        x = X + U; % previous coordinates
        x1 = X + U1; % current coordinates
         % Loop over all integration points
        for j=1:npts_per_gcell
            N = bfun(gcells(i),pc(j,:));
            Rm = material_directions(self,gcells(i),pc(j,:),x1);
            Nder = bfundpar (gcells(i), pc(j,:));
            Nderx1=bfundsp(gcells(i),Nder,x1*Rm);
            NderX=bfundsp(gcells(i),Nder,X*Rm);
            detJ = Jacobian_volume(gcells(i),pc(j,:),x1);
            F1 = x1'*NderX;%def_grad(gcells(i), NderX, x1);
%             F = x'*NderX;%def_grad(gcells(i), NderX, x);
            B = Blmat3(self, Nderx1, Rm);
            [dE,matstates{i,j}] = update(mat, matstates{i,j}, struct ('output','strain_energy','F',F1));
            E = E + dE * detJ * w(j); % note the sign
        end
     end
    return;
end
