% Draw a graphic representation.
%
% function draw (self, gv, context)
%
%
% Input arguments
% self = self
% gv = graphic viewer
% context = struct
% with mandatory fields
%    geom=geometry field
% with optional fields
% facecolor = color of the faces, solid
% colorfield =field with vertex colors
% only one of the facecolor and colorfield may be supplied
%  shrink = shrink factor
%
function draw (self, gv, context)
    % these are all defined in clockwise order, which is what Matlab expects
    context.faces=[1,7,5;3,6,7;2,5,6;7,6,5;1,5,8;2,9,5;4,8,9;5,9,8;2,6,9;3,10,6;4,9,10;6,10,9;3,7,10;1,8,7;4,10,8;7,8,10];
    context.edges= [1, 7, 3; 3, 6, 2; 2,5,1;2,9,4;4,8,1;4,10,3];
    node_pc=[0,0,0;1,0,0;0,1,0;0,0,1;0.5,0,0;0.5,0.5,0;0,0.5,0;0,0,0.5;0.5,0,0.5;0,0.5,0.5];
    if isfield(context,'shrink')
        c=ones(size(node_pc,1),1)*(sum(node_pc)/size(node_pc,1));
        pc=c+context.shrink*(node_pc-c);
        for j=1:size(pc,1)
            context.shrunk_pc_N{j}=bfun(self,pc(j,:));
        end
    end
    draw (self.gcellset_3_manifold, gv, context);
end
% function draw (self, gv, context)
%     f =[1,7,5;3,6,7;2,5,6;7,6,5;1,5,8;2,9,5;4,8,9;5,9,8;2,6,9;3,10,6;4,9,10;6,10,9;3,7,10;1,8,7;4,10,8;7,8,10];
%     ef =[1, 7, 3; 3, 6, 2; 2,5,1;2,9,4;4,8,1;4,10,3];
%     if (isfield(context,'edgecolor'))
%         edgecolor =context.edgecolor;
%     end
%     if (isfield(context,'colorfield'))
%     else
%         facecolor = 'red';
%         if (isfield(context,'facecolor'))
%             facecolor = context.facecolor;
%         end
%         edgecolor = 'Black';
%         if (isfield(context,'edgecolor'))
%             edgecolor = context.edgecolor;
%         end
%         options=struct ('facecolor',facecolor,'edgecolor',edgecolor);
%     end
%     if (isfield(context,'facealpha'))
%         options.facealpha = context.facealpha;
%     end
%     conns = get(self, 'conn'); % connectivity
%     for ac=1:size(conns,1)
%         conn =conns(ac,:);
%         x = gather(context.x, conn, 'values', 'noreshape'); % coordinates of nodes
%         u = gather(context.u, conn, 'values', 'noreshape'); % coordinates of nodes
%         xu=x+u;
%         if isfield(context,'shrink') & context.shrink~=1
%             pc= [0,0,0;1,0,0;0,1,0;0,0,1;0.5,0,0;0.5,0.5,0;0,0.5,0;0,0,0.5;0.5,0,0.5;0,0.5,0.5];
%             n=length(conn);
%             c=ones(n,1)*(sum(pc)/n);
%             pc=c+context.shrink*(pc-c);
%             xus=xu;
%             for j=1:n
%                 N=bfun(self,pc(j,:));
%                 xus(j,:)=N'*xu;
%             end
%             xu=xus;
%         end
%         if (isfield(context,'colorfield'))
%             colors =gather(context.colorfield, conn, 'values', 'noreshape'); % coordinates of nodes
%             options=struct ('colors',colors);
%         end
%         edgecolor='black';
%         options.edgecolor =edgecolor;
%         if ~strcmp(edgecolor,'none')
%             for i=1:size(ef,1)
%                 draw_polyline (gv, xu, ef(i,:), options);
%             end
%         end
%         options.edgecolor ='none';
%         for i=1:size(f,1)
%             draw_polygon (gv, xu, f(i,:), options);
%         end
%     end
% end