% Explicit mid-point Lie integrator constructor.
% Based on fractional steps with algorithms
% symplectic Euler and adjoined symplectic Euler  in a single step.
% Krysl P
% Explicit momentum-conserving integrator for dynamics of rigid bodies approximating the midpoint Lie algorithm
% INTERNATIONAL JOURNAL FOR NUMERICAL METHODS IN ENGINEERING 63 (15): 2171-2193 AUG 21 2005
%   Call as:
%     ri = rotint_liemid_Newmark
%
function retobj = rotint_liemid_Newmark (varargin)
    class_name='rotint_liemid_Newmark';
    parent=rotint;
    if (nargin == 0)
        self.I = eye(3,3);
        self.R = [];
        self.T = [];
        self.Omega = [];
        retobj = class(self,class_name,parent);
        return;
    elseif (nargin == 1) % cloning
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
        else
            self.I = eye(3,3);
            self.R = [];
            self.T = [];
            self.Omega = [];
            retobj = class(self,class_name,parent);
        end
        return;
    else
        error('Illegal arguments!');
    end
    return;
end

