% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self, varargin)
    if (nargin == 1)
        val = {{{'dim'}, {'dimensions when the matrix is square, scalar'}};
            {{'dimr'}, {'row dimension, scalar'}};
            {{'dimc'}, {'col dimension, scalar'}};
            {{'mat'}, {'data matrix, array [dimr,dimc]'}}};
        return;
    else
        prop_name= varargin{1};
        switch prop_name
            case 'mat'
                val = self.mat;
            case 'dim'
                val = size(self.mat,1);
            case 'dimr'
                val = size(self.mat, 1);
            case 'dimc'
                val = size(self.mat, 2);
            otherwise
                error(['Unknown property name ''' prop_name '''!']);
        end
    end
end
