

function Cylindrical_shell
    E=1e7;
    nu=0.0;
    rho=5e-9;
   
    iR= 8;
    Thickness =2;
    Length =15;
    rA=pi;
    tol= 0.001;
    Fmag=600;

    nincr = 5;
    graphics = ~false;
    cmap = jet;
    scale=1;
    nc = [4];
    nt = 1;
na = 2;

    %
    function [fens,gcells] = h8cylH8()
        [fens,gcells]=block(rA, Thickness, Length, nc,nt,na);
     end
    function [fens,gcells] = uh8cylH8(t,R, nt,nR)
        [fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher({...
            ['curve 1 arc ' num2str(-R) ' 0 ' num2str(R) ' 0 Center 0 0.000001 '],...
            ['curve 2 arc ' num2str(R) ' 0 ' num2str(-R) ' 0 Center 0 -0.000001'],...
            ['subregion 1  property 1 boundary  1  2 '],...
            ['m-ctl-point constant ' num2str(1.8*R/nR)]
            }, 1.0);
        [fens,gcells] = T3_to_Q4(fens,gcells,[]);
        [fens,gcells] = extrudeq4(fens,gcells,nt,@(xyz,k)([xyz,k*t/nt]));
        fens = transform_apply(fens,@(x,d)([x(3),x(2),-x(1)]), []);
        [fens] = to_cyl_surf(fens,gcells);
    end
    function [fens,gcells] = h8cylH27(t,R, nt,nR)
        [fens,gcells] = h8cylH8(t,R, nt,nR);
        [fens,gcells] = H8_to_H27(fens,gcells);
    end
    function [fens,gcells] = uh8cylH27(t,R, nt,nR)
        [fens,gcells] = uh8cylH8(t,R, nt,nR);
         [fens] = to_cyl_surf(fens,gcells);
        [fens,gcells] = H8_to_H27(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
    function [fens,gcells] = uh8cylH20(t,R, nt,nR)
        [fens,gcells] = uh8cylH8(t,R, nt,nR);
         [fens] = to_cyl_surf(fens,gcells);
        [fens,gcells] = H8_to_H20(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
    
    eix=1;
    clear eltyd
    
% eltyd(eix).label ='T4';
% eltyd(eix).mf =@t4cyl;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule= tet_rule(1);
% eltyd(eix).line_integration_rule=tri_rule(1);
% eltyd(eix).styl='rv-.';
% eix=eix+1;
% 
% eltyd(eix).label ='H8';
% eltyd(eix).mf =@h8cylH8;
% eltyd(eix).blf =@feblock_defor_nonlinear;
% eltyd(eix).integration_rule= gauss_rule (3,2);
% eltyd(eix).line_integration_rule=gauss_rule (2,2);
% eltyd(eix).styl='rx-.';
% eix=eix+1;
% 
% eltyd(eix).label ='NICE-T4';
% eltyd(eix).mf =@t4cyl;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule= simplex_nq_rule (3);
% eltyd(eix).line_integration_rule=tri_rule(1);
% eltyd(eix).styl='m^-';
% eix=eix+1;
% 
eltyd(eix).label ='NICE-H8';
eltyd(eix).mf =@h8cylH8;
eltyd(eix).blf =@feblock_defor_nonlinear_nice;
eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',2,'order',1));
eltyd(eix).styl='md-';
eix=eix+1;

% 
% eltyd(eix).label ='H27';
% eltyd(eix).mf =@h8cylH27;
% eltyd(eix).blf =@feblock_defor_nonlinear;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).line_integration_rule=gauss_rule(2, 3);
% eltyd(eix).styl='ks-';
% eix=eix+1;

% eltyd(eix).label ='NICE-H27';
% eltyd(eix).mf =@h8cylH27;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% eltyd(eix).styl='mh-';
% eix=eix+1;

% eltyd(eix).label ='H20R';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,2);
% eltyd(eix).line_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='ro-';
% eix=eix+1;
% % 
% 
% 
% eltyd(eix).label ='NICE-H20';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss_nice;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% eltyd(eix).styl='mo--';
% eix=eix+1;
% % 
% eltyd(eix).label ='H20';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).line_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='k>--';
% eix=eix+1;

    function [neqns,energy] =Compute
        nus = [(1-1.8.^(-(1:14)))*nu,(1:100)*0+nu];
        %          Mesh
        [fens,gcells] = eltyd(eix).mf ();
        feb = eltyd(eix).blf (struct ('mater',[], 'gcells',gcells));
        [fens, gcells]=renum_mesh_renumber(fens, gcells,...
            renum_mesh_numbering(fens,genconn(feb), 'symrcm'));
        bgcells =mesh_bdry(gcells, []);
        icl = gcell_select(fens, bgcells, struct('box', [rA,rA,-Inf,Inf,-Inf,Inf],'inflate',tol));
        bgcells =mesh_bdry(bgcells(icl), []);
        icl = gcell_select(fens, bgcells, struct('box', [rA,rA,0,0,-Inf,Inf],'inflate',2*tol));
        
        cncl = fenode_select(fens, struct('box', [-Inf,Inf,rA,rA,-Inf,Inf],'inflate',tol));
        for i=1:length (fens)
            xyz=get (fens(i),'xyz');
            x=xyz(1); y=xyz(2); z=xyz(3);
            xyz= [0, y-iR, z];
            xyz = xyz*rotmat([0, 0, -x])+ [0,iR,0];
            fens(i)=set(fens(i),'xyz', xyz);
        end
%         gv=drawmesh( {fens,gcells}); 
%         gv=drawmesh( {fens,bgcells(icl)},'gv',gv,'facecolor','blue');
%         view(3); return
        % Material
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_neohook(struct('property',prop));
        % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule));
        efeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells(icl),...
            'integration_rule',eltyd(eix).line_integration_rule));
        sfeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells,...
            'integration_rule',eltyd(eix).line_integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,0,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[-Inf,Inf,-Inf,Inf,Length,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+3;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[0,0,-Inf,Inf,0,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+1;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);

        % Number equations
        u   = numbereqns (u);
        % Now comes the nonlinear solution
        tup = 1;
        u = u*0; % zero out the displacement
        utol = 1e-5*get(u, 'neqns');
        us={};

        gv=graphic_viewer;
        
        K = start (sparse_altassem_sysmat, get(u, 'neqns'));
%         K = start (sparse_sysmat, get(u, 'neqns'));
           
        t=0; % time=load magnitude
        incr=1;
        while (incr <= nincr)
            t = t + tup / nincr;
            disp(['Increment ' num2str(incr) ]); % pause
            % Initialization
            u1 = u; % guess
            u1 = apply_ebc(u1);
            du = 0*u; % this will hold displacement increment
            du = apply_ebc(du);
            iter=1;
            gv=reset(clear(gv,[]),[]);
            draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
            draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
            while 1
                prop = property_linel_iso (struct('E',E,'nu',nus(iter)));
                mater = mater_defor_neohook(struct('property',prop));
                feb1=set(feb,'mater',mater);
                fi=force_intensity(struct('magn',[0;Fmag*t;0]));
                F = start (sysvec, get(u, 'neqns'));
                F = assemble (F, distrib_loads(efeb, geom, u, fi, 1));
                [feb1,evs] = restoring_force(feb1,geom,u1,u);       % Internal forces
                F = assemble (F, evs);
                ems=stiffness(feb1, geom, u1,u);% Current material stiffness
                ems =cat(2,ems,stiffness_geo(feb1, geom, u1,u)); % Current geometric stiffness
                K = assemble (K, ems);
                K = external_decomposition (K,  []);
                % Displacement increment
                du = scatter_sysvec(du, K\F);
                u1 = u1 + du;                                       % increment displacement
                K = reinitialize (K);
                draw(sfeb,gv, struct ('x', geom,'u',u1, 'facecolor','none'));
                camset(gv, [  -75.6602  613.9688  210.2074   20.6651   38.3517 20.5774         0         0    1.0000    5.3084]);
                pause(1)
                disp(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
                if (norm(du) < utol) break; end;                    % convergence check
                iter=iter+1;
            end
            [feb,ignore] = restoring_force(feb,geom,u1,u);        % final update
            disp(['    Converged for t=' num2str(t)]); % pause
            u = u1;                                               % update the displacement
            us{end+1} =u;
            utip=gather(u,cncl,'values','noreshape');
            mean(utip)
            incr = incr + 1;
        end
        gv=reset(clear(gv,[]),[]);
        draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
        draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
        camset(gv, [  -75.6602  613.9688  210.2074   20.6651   38.3517 20.5774         0         0    1.0000    5.3084]);
                clear K
        save ([mfilename '-nR' num2str(nR) '-nt' num2str(nt) '-' eltyd(eix).label])
    end

    for eix = 1:length(eltyd)
Compute
    end
end