function   torus_rod
    E=3*5.67e6;
    nu=0.499;
    %     E=G*(3*lambda+2*G)/(G+lambda);
    rho=5e-9;
    R= 1;
    sR =9;
    rA=pi/8;
    t= pi/2;
    Fmag=0.195e6;

    nincr = 10;
    graphics = ~false;
    cmap = jet;
    scale=1;
    nR = [2];
    nt = 8*[4];

    %
    function [fens] = to_cyl_surf(fens,gcells)
        bdry_gcells = mesh_bdry(gcells, []);
        tol=0.00001*t;
        bcl = [gcell_select(fens, bdry_gcells, ...
            struct ('box',[0 0 -100*R 100*R -100*R 100*R],'inflate',tol/2)),...
            gcell_select(fens, bdry_gcells, ...
            struct ('box',[t t -100*R 100*R -100*R 100*R],'inflate',tol/2)),...
            gcell_select(fens, bdry_gcells, ...
            struct ('box',[0 t 0 0 -100*R 100*R],'inflate',tol/2))];
        for j=setdiff((1:length(bdry_gcells)),bcl)
            conn=get(bdry_gcells(j),'conn');
            for k=1:length(conn)
                xyz=get(fens(conn(k)),'xyz');
                xyz=[xyz(1),R/norm(xyz(2:3))*xyz(2:3)];
                fens(conn(k))=set(fens(conn(k)),'xyz',xyz);
            end
        end
    end
    function [fens,gcells] = t4cyl(t,R, nt,nR)
        [fens,gcells] = h8cylH8(t,R, nt,nR);
        [fens,gcells] = t4del(fens);
    end
    function [fens,gcells] = t4cylT10(t,R, nt,nR)
        [fens,gcells] = t4cylinderdel(t,R, nt,nR);
        [fens,gcells] = T4_to_T10(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
    function [fens,gcells] = h8cylH8(t,R, nt,nR)
        [fens,gcells]=q4circle(R,log2(nR),1.0);
        [fens1,gcells1] = mirror_mesh(fens, gcells, [1,0], [0,0]);
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, t/10000);
        gcells=cat(2,gcells1,gcells2);
%         [fens1,gcells1] = mirror_mesh(fens, gcells, [0,1], [0,0]);
%         [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, t/10000);
%         gcells=cat(2,gcells1,gcells2);
        [fens,gcells] = extrudeq4(fens,gcells,nt,@(xyz,k)([xyz,k*t/nt]));
        fens = transform_apply(fens,@(x,d)([x(3),x(2),-x(1)]), []);
    end
    function [fens,gcells] = scylH8(t,R, nt,nR)
        fens(1) =fenode(struct('id',1,'xyz',[0,0]));
        fens(2) =fenode(struct('id',2,'xyz',[0,R]));
        fens(3) =fenode(struct('id',3,'xyz',[R*cos(3*pi/8),R*sin(3*pi/8)]));
        fens(4) =fenode(struct('id',4,'xyz',[R*cos(pi/8),R*sin(pi/8)]));
        fens(5) =fenode(struct('id',5,'xyz',[R,0]));
        fens(6) =fenode(struct('id',6,'xyz',[R/2,0]));
        %         [fens,gcells]=q4circle(R,log2(nR),1.0);
        gcells(1)=gcell_Q4(struct('id',1,'conn',[1,6,3,2]));
        gcells(2)=gcell_Q4(struct('id',2,'conn',[6,5,4,3]));
        [fens1,gcells1] = mirror_mesh(fens, gcells, [1,0], [0,0]);
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, t/10000);
        gcells=cat(2,gcells1,gcells2);
%         [fens1,gcells1] = mirror_mesh(fens, gcells, [0,1], [0,0]);
%         [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, t/10000);
%         gcells=cat(2,gcells1,gcells2);
        [fens,gcells] = extrudeq4(fens,gcells,nt,@(xyz,k)([xyz,k*t/nt]));
        fens = transform_apply(fens,@(x,d)([x(3),x(2),-x(1)]), []);
    end
    function [fens,gcells] = s1cylH8(t,R, nt,nR)
        [fens,gcells]=q4circle(R,log2(nR),1.0);
        fens(4) =fenode(struct('id',4,'xyz',[R*cos(pi/8),R*sin(pi/8)]));
        fens(7) =fenode(struct('id',7,'xyz',[R/2*cos(pi/8),R/2*sin(pi/8)]));
        [fens1,gcells1] = mirror_mesh(fens, gcells, [1,0], [0,0]);
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, t/10000);
        gcells=cat(2,gcells1,gcells2);
%         [fens1,gcells1] = mirror_mesh(fens, gcells, [0,1], [0,0]);
%         [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, t/10000);
%         gcells=cat(2,gcells1,gcells2);
        [fens,gcells] = extrudeq4(fens,gcells,nt,@(xyz,k)([xyz,k*t/nt]));
        fens = transform_apply(fens,@(x,d)([x(3),x(2),-x(1)]), []);
    end
    function [fens,gcells] = h8cylH27(t,R, nt,nR)
        [fens,gcells] = h8cylH8(t,R, nt,nR);
        [fens,gcells] = H8_to_H27(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
    function [fens,gcells] = scylH27(t,R, nt,nR)
        [fens,gcells] = scylH8(t,R, nt,nR);
        [fens,gcells] = H8_to_H27(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
   function [fens,gcells] = scylH64(t,R, nt,nR)
        [fens,gcells] = scylH8(t,R, nt,nR);
        [fens,gcells] = H8_to_H64(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
   function [fens,gcells] = s1cylH64(t,R, nt,nR)
        [fens,gcells] = s1cylH8(t,R, nt,nR);
        [fens,gcells] = H8_to_H64(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
   
    eix=1;
    clear eltyd
    
% eltyd(eix).label ='T4';
% eltyd(eix).mf =@t4cyl;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule= tet_rule(1);
% eltyd(eix).surface_integration_rule=tri_rule(1);
% eltyd(eix).styl='rv-.';
% eix=eix+1;
% 
% eltyd(eix).label ='H8';
% eltyd(eix).mf =@h8cylH8;
% eltyd(eix).blf =@feblock_defor_nonlinear;
% eltyd(eix).integration_rule= gauss_rule (3,2);
% eltyd(eix).surface_integration_rule=gauss_rule (2,2);
% eltyd(eix).styl='rx-.';
% eix=eix+1;
% 
eltyd(eix).label ='NICE-T4';
eltyd(eix).mf =@t4cyl;
eltyd(eix).blf =@feblock_defor_nonlinear_nice;
eltyd(eix).integration_rule= simplex_nq_rule (3);
eltyd(eix).surface_integration_rule=tri_rule(1);
eltyd(eix).styl='m^-';
eix=eix+1;
% 
% eltyd(eix).label ='NICE-H8';
% eltyd(eix).mf =@h8cylH8;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',1));
% eltyd(eix).styl='md-';
% eix=eix+1;

% eltyd(eix).label ='T10';
% eltyd(eix).mf =@t4cylT10;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=tet_rule (4);
% eltyd(eix).surface_integration_rule=tri_rule(3);
% eltyd(eix).styl='kv--';
% eix=eix+1;
% 
% eltyd(eix).label ='H27';
% eltyd(eix).mf =@h8cylH27;
% eltyd(eix).blf =@feblock_defor_nonlinear;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 3);
% eltyd(eix).styl='ks-';
% eix=eix+1;

% eltyd(eix).label ='NICE-H27';
% eltyd(eix).mf =@scylH27;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% eltyd(eix).styl='mh-';
% eix=eix+1;

% eltyd(eix).label ='NICE-H64';
% eltyd(eix).mf =@s1cylH64;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',3));
% eltyd(eix).styl='mh-';
% eix=eix+1;

% eltyd(eix).label ='H20R';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,2);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='ro-';
% eix=eix+1;
% % 
% 
% 
% eltyd(eix).label ='NICE-H20';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss_nice;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% eltyd(eix).styl='mo--';
% eix=eix+1;
% % 
% eltyd(eix).label ='H20';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='k>--';
% eix=eix+1;

    function [neqns,energy] =Compute(nR,nt)
        nus = [(1-1.8.^(-(1:14)))*nu,(1:100)*0+nu];
        %          Mesh
        [fens,gcells] = eltyd(eix).mf (t,R, nt,nR);
        feb = eltyd(eix).blf (struct ('mater',[], 'gcells',gcells));
        [fens, gcells]=renum_mesh_renumber(fens, gcells,...
            renum_mesh_numbering(fens,genconn(feb), 'symrcm'));
        bgcells =mesh_bdry(gcells, []);
        icl = gcell_select(fens, bgcells, struct('box', [0,rA,-R*sin(rA),R*sin(rA),R*cos(rA),Inf],'inflate',R/100));
        for i=1:length (fens)
            xyz=get (fens(i),'xyz');
            a=xyz(1); y=xyz(2); z=xyz(3);
            xyz= [0, y, z+sR];
            xyz = xyz*rotmat([0, -a, 0]);
            fens(i)=set(fens(i),'xyz', xyz);
        end
%         gv=drawmesh( {fens,gcells},'facecolor','none'); gv=drawmesh( {fens,bgcells(icl)},'gv',gv,'facecolor','blue');
%         view(3); pause(1)
        % Material
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_neohook(struct('property',prop));
        % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule));
        efeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells(icl),...
            'integration_rule',eltyd(eix).surface_integration_rule));
        sfeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells,...
            'integration_rule',eltyd(eix).surface_integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,-100*sR,100*sR,-100*sR,100*sR],'inflate',R/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+1;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[-100*sR,100*sR,0,0,-100*sR,100*sR],'inflate',R/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+2;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[-100*sR,100*sR,-100*sR,100*sR,0,0],'inflate',R/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+3;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);

        % Number equations
        u   = numbereqns (u);
        % Now comes the nonlinear solution
        tup = 1;
        u = u*0; % zero out the displacement
        utol = 1e-13*get(u, 'neqns');

        gv=graphic_viewer;
        
%         K = start (sparse_altassem_sysmat, get(u, 'neqns'));
        K = start (sparse_colsol_sysmat, get(u, 'neqns'));
           
        t=0; % time=load magnitude
        incr=1;
        while (incr <= nincr)
            t = t + tup / nincr;
            disp(['Increment ' num2str(incr) ]); % pause
            % Initialization
            u1 = u; % guess
            u1 = apply_ebc(u1);
            du = 0*u; % this will hold displacement increment
            du = apply_ebc(du);
            iter=1;
%             gv=reset(clear(gv,[]),[]);
            %             draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
            while 1
                prop = property_linel_iso (struct('E',E,'nu',nus(iter)));
                mater = mater_defor_neohook(struct('property',prop));
                feb1=set(feb,'mater',mater);
                %                 feb1=feb;                                           % Make a copy of the state
                Load=zeros(3,1); Load(3) =-Fmag*t;
                fi=force_intensity(struct('magn',Load));
                F = start (sysvec, get(u, 'neqns'));
                F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
                [feb1,evs] = restoring_force(feb1,geom,u1,u);       % Internal forces
                F = assemble (F, evs);
                K = assemble (K, stiffness(feb1, geom, u1,u));
                K = assemble (K, stiffness_geo(feb1, geom, u1,u));
                K = external_decomposition (K,  []);
                % Displacement increment
                du = scatter_sysvec(du, K\F);
                u1 = u1 + du;                                       % increment displacement
                K = reinitialize (K);
                %                 draw(sfeb,gv, struct ('x', geom,'u',u1, 'facecolor','none'));
                %                 pause(1)
                disp(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
                if (norm(du) < utol) break; end;                    % convergence check
                iter=iter+1;
            end
            [feb,ignore] = restoring_force(feb,geom,u1,u);        % final update
            disp(['    Converged for t=' num2str(t)]); % pause
            u = u1;                                               % update the displacement
            gv=reset(clear(gv,[]),[]);
            %             draw(sfeb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
            %             draw(sfeb,gv, struct ('x', geom,'u',0*u, 'facecolor','none'));
            fld = field_from_integration_points(feb, geom, u1, [], 'Cauchy',3);
            nvals=get(fld,'values');%min(nvals),max(nvals)
            nvalsrange=[min(nvals),max(nvals)];
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(sfeb,gv, struct ('x', geom, 'u', +scale*u,'colorfield',colorfield, 'shrink',1.0));
            draw(sfeb,gv, struct ('x', geom, 'u', 0*u,'facecolor','none', 'shrink',1.0));
            % draw(efeb,gv, struct ('x', geom, 'u', 0*u,'facecolor','red', 'shrink',1.0));
            colormap(cmap);
            cbh=colorbar;
            set(cbh,...
                'Position',[0.815 0.15 0.05 0.7],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            set(get(cbh,'XLabel'),'String','\sigma_z');
            pause(0.5);
            incr = incr + 1;
        end
        clear K
        save ([mfilename '-nR' num2str(nR) '-nt' num2str(nt) '-' eltyd(eix).label])
    end

    for eix = 1:length(eltyd)
        for i=1:length(nR)
            for j=1:length(nt)
                Compute(nR(i),nt(j));
            end
        end
    end
end