% Parameters:
E=1.0e7;
nu=0.25;
rin=0.74;
rex =0.95;
t= 0.1;
uc=[-2.0,-1.2,0.5, 50]'/100;
vc=[1.2,0.0,0, 0]'/100;
wc=[-0.5,0.0,0, 0]'/100;
uc=[ 0,  3.3, 0, 0]'/10;
vc=[ 3.3,0, 0, 0]'/10;
wc=[0, 0, 0, 0]'/10;
component = 4;

scale = 1;
graphics = true;

eix=1;
clear eltyd
%
% % NICE tetrahedron
% eltyd(eix).label ='NICE-T4';
% eltyd(eix).mf =@t4block;
% eltyd(eix).blf =@feblock_defor_ss_nicer;
% eltyd(eix).integration_rule= simplex_nq_rule (3);
% eltyd(eix).surface_integration_rule=tri_rule(1);
% eltyd(eix).styl='m^-';
% eix=eix+1;
%
% % NICE  hexahedron
% eltyd(eix).label ='NICE-H8';
% eltyd(eix).mf =@block;
% eltyd(eix).blf =@feblock_defor_ss_nicer;
% eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',1));
% eltyd(eix).styl='md-';
% eix=eix+1;
%
% % Full integration 27-node hexahedron
eltyd(eix).label ='H27';
eltyd(eix).mf =@blockH27;
eltyd(eix).subdiv =1;
eltyd(eix).blf =@feblock_defor_ss;
eltyd(eix).integration_rule=gauss_rule (3,3);
eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
eltyd(eix).styl='k<-';
eix=eix+1;
%
% % NICE  27-node hexahedron
% % eltyd(eix).label ='NICE-H27';
% % eltyd(eix).mf =@blockH27;
% % eltyd(eix).blf =@feblock_defor_ss_nicer;
% % eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% % eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% % eltyd(eix).styl='ks-';
% % eix=eix+1;
%
% % Reduced integration H20
% eltyd(eix).label ='H20R';
% eltyd(eix).mf =@blockH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,2);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='ro-';
% eix=eix+1;
% %
% % NICE H20
% eltyd(eix).label ='NICE-H20';
% eltyd(eix).mf =@blockH20;
% eltyd(eix).blf =@feblock_defor_ss_nicer;
% eltyd(eix).integration_rule=serendipity_nq_rule (struct('dim',3,'order',1));
% eltyd(eix).surface_integration_rule=serendipity_nq_rule (struct('dim',2,'order',1));
% eltyd(eix).styl='ko-';
% eix=eix+1;
%
% % Full integration H20
% eltyd(eix).label ='H20';
% eltyd(eix).mf =@blockH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='b*-';
% eix=eix+1;

% % T10 tetrahedron
% eltyd(eix).label ='T10';
% eltyd(eix).mf =@t4blockT10;
% eltyd(eix).subdiv =1;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=tet_rule (4);
% eltyd(eix).surface_integration_rule=tri_rule(3);
% eltyd(eix).styl='gd-';
% eix=eix+1;
%

% Selective reduced integration hexahedron
% eltyd(eix).label ='H8-SRI';
% eltyd(eix).mf =@block;
% eltyd(eix).blf =@feblock_defor_ss_sri;
% eltyd(eix).integration_rule=gauss_rule (3,[1,2]);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='ks--';
% eix=eix+1;

% Full integration hexahedron
% eltyd(eix).label ='H8';
% eltyd(eix).mf =@block;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,2);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='mx--';
% eix=eix+1;

mix = 1;
clear mesd
mesd(mix).nl= 4;
mesd(mix).nt=2;
mix = mix+1;

for eix = 1:length(eltyd)

    for mix = 1:length(mesd)
        ns=[];
        uzs=[];
        neqns = [];

        for     nl=mesd(mix).nl;
            for     nt=mesd(mix).nt;
                %% Create the mesh and initialize the geometry
                [fens,gcells]= feval (eltyd(eix).mf, rex-rin,pi/2,t,nt,nl,nt);
                bdry_gcells = mesh_bdry(gcells, []);
                icl = gcell_select(fens, bdry_gcells, struct('box', [-100*rex, 100*rex,pi/2,pi/2,-100*rex, 100*rex],'inflate',rin/100));
                xy=get (fens,'xyz');
                for i=1:length (fens)
                    r=rin+xy(i,1); a=xy(i,2);
                    xy(i,:)=[r*cos(a) r*sin(a) xy(i,3)];
                end
                fens=set(fens,'xyz', xy);
                %                 mesh{1}=fens;
                %                 mesh{2}=gcells;
                %                 drawmesh(mesh); view(3); pause (1)
                %                 mesh{1}=fens;
                %                 mesh{2}=bdry_gcells(icl);
                %                 drawmesh(mesh); view(3); pause (1)
                prop = property_linel_iso (struct('E',E,'nu',nu));
                mater = mater_defor_ss_linel_triax (struct('property',prop));

                feb = feval (eltyd(eix).blf, struct ('mater',mater, 'gcells',gcells, 'integration_rule',eltyd(eix).integration_rule));
                geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));

                %% Define the displacement field, and zero it out
                u   = 0*geom;

                %% Apply the EBC''s
                bdry_gcells = mesh_bdry(gcells,  []);
                conns=get(bdry_gcells,'conn');
                xy=get(fens,'xyz');
                for j=1:length(bdry_gcells)
                    conn =conns(j,:);
                    for k=1:length(conn)
                        u1=xy(conn(k),:)*uc(1:3)+uc(4);
                        v1=xy(conn(k),:)*vc(1:3)+vc(4);
                        w1=xy(conn(k),:)*wc(1:3)+wc(4);
                        [u1,v1,w1]
                        u   = set_ebc(u,[conn(k),conn(k),conn(k)], [1,1,1], [1,2,3], [u1,v1,w1]);
                    end
                end
                u   = apply_ebc (u);

                %% Number the equations
                u   = numbereqns (u);
                disp ([eltyd(eix).label ': number of equations =' num2str(get(u,'neqns'))])

                %% Assemble the stiffness matrix
                K = start (sparse_sysmat, get(u, 'neqns'));
                %                 K = start (sparse_sysmat, get(u, 'neqns'));
                ems=stiffness(feb, geom, u);
                K = assemble (K, ems);
                %                 figure;spy(get(K,'mat'));

                %% Assemble the load vector
                F = start (sysvec, get(u, 'neqns'));
                F = assemble (F, nz_ebc_loads(feb, geom, u));
    
                %% Solve K*u=F
                b=get(F,'vec');%sum(b)
                x=get(K,'mat')\b;
                %     a=get(K,'mat');
                %     x = bicg(get(K,'mat'),get(F,'vec'), 1e-6, 14000, diag(diag (get(K,'mat'))));
                %     x=0*b;
                %     for it = 1:50
                %         res=b-a*x;
                %         norm (res)
                %         x= x+a\res;
                %     end
                %     [Lf,Uf]=lu(a);
                %     x=Uf\(Lf\b);

                %% Transfer the solution to the field u
                u = scatter_sysvec(u, x);
                se= 1/2*x'*get(F,'vec')
                

                %% Plot the displacement field u
                if graphics
                    gv=graphic_viewer;
                    gv=reset (gv,[]);
                    % draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','none'));
                    fld = field_from_integration_points(feb, geom, u, [], 'Cauchy', component);
                    nvals=get(fld,'values');
                    dcm=data_colormap(struct ('range',[min(nvals),max(nvals)], 'colormap',jet));
                    colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
                    draw(feb, gv, struct ('x',geom,'u', scale*u, 'colorfield',colorfield, 'shrink',0.9));
                    draw(feb, gv, struct ('x',geom,'u', 0*u, 'facecolor','none','edgecolor','black', 'shrink',0.9));
                    colormap(jet);
                    cbh=colorbar;
                    set(cbh,...
                        'Position',[0.8 0.15 0.03 0.7],...
                        'YLim',[0,1],...
                        'YTick',[0,1],...
                        'YTickLabel',{[num2str(min(nvals))],[num2str(max(nvals))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
                    set(get(cbh,'XLabel'),'String','\sigma');
                    title ('Stress');
                    camset (gv, [6.2644    1.2063    7.9557    0.5785    0.4577    0.0621         0         0    1.0000   10.3396])
                else
                    %                     plot(nels,uzs/uzex,eltyd(eix).styl,'linewidth',3); hold on
                    plot(neqns,abs((uzs-uzex)/uzex),eltyd(eix).styl,'linewidth',3); hold on
                    set(gca,'XScale','log')
                    set(gca,'YScale','log')
%                     set(gca,'XLim',[100,1e4])
%                     set(gca,'YLim',[1e-3,1.0])
                    grid on
                    figure (gcf); pause (1)
                end
            end
        end
    end
end