function rltb_test
    E=1000;
    nu=0.4999999;
    nu=0.4999;%Taylor data
    nu=0.3;%for condition number estimates
    W=2.5;
    H=5;
    L= 50;
    htol=min([L,H,W])/1000;
    uzex =-12.6;
    magn = 0.2*uzex/4;
    Force =magn*W*H*2;
    Force*L^3/(3*E*W*H^3*2/12);
    graphics =~true;
    Amplitude_fraction=0.3962;
    Amplitude_fraction=0.;
        
    clear eltyd
    eix=1;

    % NICE tetrahedron
%     eltyd(eix).mf =@perturbed_t4block;
%     eltyd(eix).blf =@feblock_defor_ss_nice;
%     eltyd(eix).integration_rule= simplex_nq_rule (3);
%     eltyd(eix).surface_integration_rule=tri_rule(1);
%     eltyd(eix).styl='c*-';
%     eix=eix+1;

    % % Regular tetrahedron
    eltyd(eix).mf =@perturbed_t4block;
    eltyd(eix).blf =@feblock_defor_ss;
    eltyd(eix).integration_rule= tet_rule (1);
    eltyd(eix).surface_integration_rule=tri_rule(1);
    eltyd(eix).styl='kv:';
    eix=eix+1;

    % % NICE tetrahedron
    eltyd(eix).mf =@perturbed_t4block_wslivers;
    eltyd(eix).blf =@feblock_defor_ss_nice;
    eltyd(eix).integration_rule= simplex_nq_rule (3);
    eltyd(eix).surface_integration_rule=tri_rule(1);
    eltyd(eix).styl='k*-';
    eix=eix+1;

    % % NICE tetrahedron
    eltyd(eix).mf =@perturbed_t4block;
    eltyd(eix).blf =@feblock_defor_ss_nice;
    eltyd(eix).integration_rule= simplex_nq_rule (3);
    eltyd(eix).surface_integration_rule=tri_rule(1);
    eltyd(eix).styl='ks--';
    eix=eix+1;

    % NICE  hexahedron
    % eltyd(eix).mf =@block;
    % eltyd(eix).blf =@feblock_defor_ss_nice;
    % eltyd(eix).integration_rule= tensprod_nq_rule (3);
    % eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
    % eltyd(eix).styl='cd-';
    % eix=eix+1;

    mix = 1;
%     mesd(mix).mult=4;
%     mesd(mix).ns=1;
%     mix = mix+1;
    %
    % mesd(mix).mult=2;
    % mesd(mix).ns=2;
    % mix = mix+1;
% 
    mesd(mix).mult=4;
    mesd(mix).ns=(2:7);
    mix = mix+1;

    % mesd(mix).mult=4;
    % mesd(mix).ns=(3:7);
    % mix = mix+1;

    for eix = 1:length(eltyd)
        condition_numbers=[];
        number_of_equations=[];
        for mix = 1:length(mesd)
            ns=[];
            uzs=[];

            for     n=mesd(mix).ns;
                mult =mesd(mix).mult;
                %% Create the mesh and initialize the geometry
                rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
                [fens,gcells]= feval (eltyd(eix).mf, W, L, H,n,mult*n,2*n);
                %                    mesh{1}=fens;
                %                     mesh{2}=gcells;
                %                     drawmesh(mesh,'shrink', 0.8,'facecolor','red');
                prop = property_linel_iso (struct('E',E,'nu',nu));
                mater = mater_defor_ss_linel_triax (struct('property',prop));

                feb = feval (eltyd(eix).blf, struct ('mater',mater, 'gcells',gcells, 'integration_rule',eltyd(eix).integration_rule));
                geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));

                conns =get(gcells,'conn' );
                    xyz =get(fens,'xyz');
                Volumes =T4_volume(conns,xyz);

                disp(['Tetrahedron Volumes: '...
                    num2str(sum(Volumes>0))  ' positive, ' ...
                    num2str(sum(Volumes==0))  ' zero, '...
                    num2str(sum(Volumes<0))  ' negative' ...
                    ]);

                %% Define the displacement field, and zero it out
                u   = 0*geom;

                %% Apply the EBC''s
                ebc_fenids=fenode_select(fens,struct('box',[0 W 0 0 0 H]));
                ebc_prescribed=ones(length(ebc_fenids),1);
                ebc_comp=[];
                ebc_val=zeros(length(ebc_fenids),1);
                u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
                ebc_fenids=fenode_select(fens,struct('box',[W W 0 L 0 H]));
                ebc_prescribed=ones(length(ebc_fenids),1);
                ebc_comp=ebc_fenids*0+1;
                ebc_val=zeros(length(ebc_fenids),1);
                u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
                u   = apply_ebc (u);

                %% Number the equations
                u   = numbereqns (u);
                disp (['n=' num2str(n) ', number of equations =' num2str(get(u,'neqns'))])

                %% Assemble the stiffness matrix
                K = start (sparse_sysmat, get(u, 'neqns'));
                K = assemble (K, stiffness(feb, geom, u));

                %% Assemble the load vector
                fi= force_intensity(struct ('magn',[0;0; magn]));
                bdry_gcells = mesh_bdry(gcells, []);
                bcl = gcell_select(fens, bdry_gcells, ...
                    struct ('box',[0 W L L 0 H],'inflate',htol));
                lfeb = feblock_defor_ss(struct ('mater',mater, 'gcells',subset(bdry_gcells,bcl),...
                    'integration_rule',eltyd(eix).surface_integration_rule));
                F = start (sysvec, get(u, 'neqns'));
                F = assemble (F, distrib_loads(lfeb, geom, u, fi,2));
                F = finish(F);

% figure;                spy(get(K,'mat'))
                %% Solve K*u=F
                mK=get(K,'mat');
                c=condest(mK,4);
                disp( [' Condition number estimate=' num2str(c)] )
                condition_numbers=[condition_numbers,c];
        number_of_equations=[number_of_equations,get(u, 'neqns')];
                %     a=get(K,'mat');
                %     x = bicg(get(K,'mat'),get(F,'vec'), 1e-6, 14000, diag(diag (get(K,'mat'))));
                %     x=0*b;
                %     for it = 1:50
                %         res=b-a*x;
                %         norm (res)
                %         x= x+a\res;
                %     end
                %     [Lf,Uf]=lu(a);
                %     x=Uf\(Lf\b);

                %% Transfer the solution to the field u
                u = scatter_sysvec(u, K\F);
                ebc_fenids=fenode_select(fens,struct('box',[0 W L L 0 H]));
                uv=gather (u,ebc_fenids,'values','noreshape');
                uz=sum(uv(:, 3))/length(ebc_fenids);
                disp (['   Free end displacement =' num2str(uz)])
                ns=[ns n];
                uzs =[uzs uz];

                %% Plot the displacement field u
                if graphics
                    gv=graphic_viewer;
                    gv=reset (gv,[]);
                    scale=1;
%                     draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','none'));
%                     fld = field_from_integration_points(feb, geom, u, [], 'Cauchy', 2);
%                     nvals=get(fld,'values');
%                     dcm=data_colormap(struct ('range',[min(nvals),max(nvals)], 'colormap',jet));
%                     colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
%                     draw(feb, gv, struct ('x',geom,'u', scale*u, 'colorfield',colorfield, 'shrink',1));
%                     draw(feb, gv, struct ('x',geom,'u', scale*u,'facecolor','yellow', 'shrink',1));
%                     colormap(jet);
%                     cbh=colorbar;
%                     set(cbh,...
%                         'Position',[0.8 0.15 0.1 0.7],...
%                         'YLim',[0,1],...
%                         'YTick',[0,1],...
%                         'YTickLabel',{[num2str(min(nvals))],[num2str(max(nvals))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
%                     set(get(cbh,'XLabel'),'String','\sigma_{y}');
%                     title ('Stress');
                    camset (gv, [362.6179  179.7380  186.8838    4.5277   24.0360   -3.5642   -0.4020   -0.1748  0.8988    3.9476])
                    %                 camset (gv, [-577.5531  612.4095  322.0260    4.5854   46.3526  -10.6875    0.2718   -0.2643    0.9253    3.5144])
                    draw(bdry_gcells, gv, struct ('x',geom,'u', scale*u,'facecolor','yellow', 'shrink',0.99));
                    headlight(gv);
                else
%                     plot(ns,uzs/uzex,eltyd(eix).styl,'linewidth',3); hold on
%                     xlabel('Number of elements multiplier n [ND]');
%                     ylabel('Normalized deflection of the tip [ND]');
%                     figure (gcf); pause (1)
%                     set_graphics_defaults
                end
            end
            loglog(number_of_equations,condition_numbers,eltyd(eix).styl,'linewidth',3); hold on
            xlabel('Number of unknowns [ND]');
            ylabel('Condition number [ND]');
            grid on;
            set_graphics_defaults
            figure (gcf);
        end
    end
    
    
    function [fens,gcells] =  perturbed_t4block(Length,Width,Height,nL,nW,nH)
        function  u=fx(xyz)
            u=Amplitude_fraction*rand(size(xyz,1),1)*(Length/nL);
        end
        function  u=fy(xyz)
            u=Amplitude_fraction*rand(size(xyz,1),1)*(Width/nW);
        end
        function  u=fz(xyz)
            u=Amplitude_fraction*rand(size(xyz,1),1)*(Height/nH);
        end
         [fens,gcells] = T4_block(Length,Width,Height,nL,nW,nH);
        options.displacement ={@fx,@fy,@fz};
        fens = block_function_shift(fens, options);
    end

    
    function [fens,gcells] =  perturbed_t4block_wslivers(Length,Width,Height,nL,nW,nH)
        function  u=fx(xyz)
            u=Amplitude_fraction*rand(size(xyz,1),1)*(Length/nL);
        end
        function  u=fy(xyz)
            u=Amplitude_fraction*rand(size(xyz,1),1)*(Width/nW);
        end
        function  u=fz(xyz)
            u=Amplitude_fraction*rand(size(xyz,1),1)*(Height/nH);
        end
        [fens,gcells] = T4_block_wslivers(Length,Width,Height,nL,nW,nH);
        options.displacement ={@fx,@fy,@fz};
        fens = block_function_shift(fens, options);
    end

end