disp(' ');
disp('Real slow Lagrangian top');
[fens,gcells] = H8_hexahedron([-1, -1, 0; 1, 1, 18],1, 1, 1);
feb = feblock(struct('gcells',gcells));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
u = 0*geom;
graphics= ~true;
Width=60; Height=60; Length=8*Width;% cross-sectional dimensions and length of each leg in millimeters
% Principal components of the tensor of inertia with respect to the origin of the coordinate system
rho=2.7e-9;
Mass=Width*Height*Length*rho;
IL= (1/12)*Mass*(Width^2+Height^2);
Ib= (1/12)*Mass*(Length^2+Height^2)+Mass*(Length/2)^2;
Ih= (1/12)*Mass*(Width^2+Length^2)+Mass*(Length/2)^2;
Omega0=90*pi;
g=9.81e3; % 9.81 meters per second squared
dt=min( [2*pi/norm(Omega0)/50, 0.001]);
    tend=3;
nmarkers=10;
marker_type='oxd*sdv^<>ph';
colors=['r'; 'g'; 'b'; 'k'];
dts=[1/8 1/16 1/32 1/64 1/128 1/256 1/512 ];
dts=[dt];
setnum=0;
for plotwhat={'5'}
    for rin={'dyneq_imidm'}
%         for rin={'dyneq_trap' 'dyneq_trapm' 'dyneq_imid' 'dyneq_imidm'}
%       for rin={'bb_rkmk_trap' 'simo_wong_algo_c1' 'akw_mid'}
        ri=eval(['rotint_' rin{1}]);
        nRs=[];
        nmbfs=[];
        nmsps=[];
        for dt=dts;
            % Data, Initial conditions
            torque = @(t,R)(-skewmat(R(:,3))*[0;0;Length/2]*g*Mass);
            % Data, Initial conditions
            I=[Ib 0 0; 0 Ih 0; 0 0 IL];
            R = rotmat([0.05 0 0]);
            omega = R*[0 0 Omega0]';
            exactkinenergy=omega'*R*I*R'*omega/2;
            exacthamilt=exactkinenergy+R(:,3)'*[0;0;Length/2]*g*Mass;
            Omega=R'*omega;
            converged_R_at_20 = [
                -1.322160948371581e-001   -9.911525719838213e-001   -1.163973005990285e-002
    9.858393579154383e-001   -1.302672123901182e-001   -1.055993075781468e-001
    1.031487501179139e-001   -2.543683207405415e-002    9.943406372683098e-001
            ];
            converged_Omega_at_20 = [
                8.415781079386203e-002
    1.679120248050994e-001
    5.000000000562824e+000
            ];
            line='-';
            % Choose integrator
            ri = set(ri, 'I', I);
            ri = set(ri, 'R', R);
            ri = set(ri, 'omega', omega);

            limits=1.1*[-18, 18, -18, 18, -18, 18];
            nsteps=round(tend/dt);
            reportat=nsteps/20;

            omegas=zeros(3,nsteps+1);
            momenta=zeros(3,nsteps+1);
            kinenergy=zeros(1,nsteps+1);
            potenergy=zeros(1,nsteps+1);
            etas=zeros(1,nsteps+1);
            Omegas=zeros(3,nsteps+1);
            vectup=zeros(3,nsteps+1);
            incrrotvect=zeros(3,nsteps+1);
            rotvect=zeros(3,nsteps+1);
            incrrotvectmag=zeros(1,nsteps+1);
            if graphics
                gv=graphic_viewer;
                gv=reset (gv,struct('limits',limits));
                draw(feb, gv,  struct ('x',geom,'u', u, 'facecolor','red'));
                headlight(gv);
            end
            tic;
            ri = set(ri, 't', 0);
            % store history for t=0
            snapshot=1;
            omega=get(ri, 'omega');
            R1=R;
            R=get(ri, 'R');
            V=rotmat2rotvec((R1')*R);
            incrrotvect(:,snapshot)=V;
            incrrotvectmag(:,snapshot)=norm(V)*180/pi;
            rotvect(:,snapshot)=rotmat2rotvec(R);
            omegas(:,snapshot)=omega;
            Omegas(:,snapshot)=R'*omega;
            L=R*I*R'*omega;
            momenta(:,snapshot)=L;
            kinenergy(snapshot)= 1/2*omega'*L;
            potenergy(snapshot)= +R(:,3)'*[0;0;Length/2]*g*Mass;
            etas(snapshot)=get(ri,'eta');
            vectup(:,snapshot)=R(:,3);
            for i=1:nsteps
                % advance by one step
                ri = advance(ri, torque,dt,1);
                % save history
                snapshot=snapshot+1;
                omega=get(ri, 'omega');
                R1=R;
                R=get(ri, 'R');
                V=rotmat2rotvec((R1')*R);
                incrrotvect(:,snapshot)=V;
                incrrotvectmag(:,snapshot)=norm(V)*180/pi;
                rotvect(:,snapshot)=rotmat2rotvec(R);
                omegas(:,snapshot)=omega;
                Omegas(:,snapshot)=R'*omega;
                L=R*I*R'*omega;
                momenta(:,snapshot)=L;
                kinenergy(snapshot)= 1/2*omega'*L;
                potenergy(snapshot)= +R(:,3)'*[0;0;Length/2]*g*Mass;
                etas(snapshot)=get(ri,'eta');
                vectup(:,snapshot)=R(:,3);
                % graphics
                if graphics
                    currgeom=rotate(geom, R);
                    u=currgeom-geom;
                    gv=reset (gv,struct('limits',limits));
                    draw(feb, gv,  struct ('x',geom,'u', 0*u, 'facecolor','none'));
                    draw(feb, gv,  struct ('x',geom,'u', u, 'facecolor','red'));
                    headlight(gv); view(3)
                    pause(0.5); % next eigenvector
                end
                if (round(i/(reportat))*reportat == i)
                    disp([num2str(i) ' steps of ' num2str(nsteps)]);
                end
            end
            %             disp(['Reached time ' num2str(get(ri,'t'))]);
            %             toc

            
            hold on
            npts=size(momenta,2);
            setnum=setnum+1;
            set(gca,'LineWidth',2);
            set(gca,'FontSize',16);
            set(gca,'TickLength',[0.025 0.06]);  % default values are: 0.0100 0.0250
            set(gca,'XGrid','on');
            set(gca,'YGrid','on');
            xlabel('Time');
            plotwhat1=plotwhat{1};
            if (~strcmp(class(plotwhat{1}),'char'))
                plotwhat1=num2str(plotwhat);
            end
            switch plotwhat1
                case {'0' 'kin'}
                    ylabel('Kinetic energy');
                    filename=[mfilename(1) '-kin-' num2str(dt)];
                    plot(dt*(0:npts-1), kinenergy(1:npts), [colors(4) line], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), kinenergy(markers), [colors(4) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                case '1'
                    ylabel('Normalized Kinetic energy');
                    filename=[mfilename '-normkin-' num2str(dt)];
                    plot(dt*(0:npts-1), (kinenergy(1:npts)-exactkinenergy)/exactkinenergy, [colors(4) line], 'LineWidth', 1.5);
                    plot(dt*(markers-1), (kinenergy(markers)-exactkinenergy)/exactkinenergy, [colors(4) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                case '2'
                    ylabel('Angular velocity/body frame');
                    filename=[mfilename '-bfOmega-' num2str(dt)];
                    plot(dt*(0:npts-1), Omegas(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Omegas(2,1:npts), [colors(2) '--'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Omegas(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\Omega_1', '\Omega_2', '\Omega_3');
                case '3'
                    ylabel('Angular velocity/spatial frame');
                    filename=[mfilename '-omega-' num2str(dt)];
                    plot(dt*(0:npts-1), omegas(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), omegas(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), omegas(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\omega_1', '\omega_2', '\omega_3');
                case {'4' 'mom' 'pi'}
                    ylabel('Spatial angular momenta');
                    filename=[mfilename '-mom-' num2str(dt)];
                    plot(dt*(0:npts-1), momenta(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), momenta(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), momenta(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\pi_1', '\pi_2', '\pi_3');
                case '5'
                    xlabel('x-component of vector-up');
                    ylabel('x-component of vector-up');
                    filename=[mfilename '-vectup-' num2str(dt)];
                    hold on
                    axis equal
                    set_graphics_defaults
                    plot(vectup(1,:), vectup(2,:), ['r-'],  'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    %                     plot(vectup(1,markers), vectup(2,markers), ['b'  marker_type(mod(setnum,length(marker_type))+1)],  'LineWidth', 1.5); 
                case '6'
                    ylabel('Incremental rotation vector');
                    filename=[mfilename '-incrrotvec-' num2str(dt)];
                    plot(dt*(0:npts-1), incrrotvect(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), incrrotvect(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), incrrotvect(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\Delta\Theta_1', '\Delta\Theta_2', '\Delta\Theta_3');
                case '7'
                    ylabel('Magnitude of incremental rotation vector');
                    filename=[mfilename '-incrrotvecmag-' num2str(dt)];
                    plot(dt*(0:npts-1), incrrotvectmag(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvectmag(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                case '8'
                    ylabel('Rotation vector');
                    filename=[mfilename '-rotvec-' num2str(dt)];
                    plot(dt*(0:npts-1), rotvect(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), rotvect(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), rotvect(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\Theta_1', '\Theta_2', '\Theta_3');
                case '14'
                    ylabel('Norm of spatial angular momenta');
                    filename=[mfilename '-nmom-' num2str(dt)];
                    nm=sqrt(momenta(1,:).*momenta(1,:)+momenta(2,:).*momenta(2,:)+momenta(3,:).*momenta(3,:));
                    plot(dt*(0:npts-1), nm, [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), nm(markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('||\pi||');
                case {'Pi'}
                    ylabel('Angular momenta/body frame');
                    filename=[mfilename '-Pi-' num2str(dt)];
                    Pis=Omegas;
                    for i=1:npts
                        Pis(:,i)=I*Omegas(:,i);
                    end
                    plot(dt*(0:npts-1), Pis(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Pis(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Pis(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Pis(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Pis(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Pis(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\Pi_1', '\Pi_2', '\Pi_3');
                case {'13' 'hamilt'}
                    ylabel('Hamiltonian');
                    filename=[mfilename '-hamilt-' num2str(dt)];
                    plot(dt*(0:npts-1), (kinenergy+potenergy), [colors(mod(setnum,length(colors))+1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), (kinenergy(markers)+potenergy(markers)), [colors(mod(setnum,length(colors))+1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('Hamiltonian');
                case {'eta'}
                    ylabel('\eta');
                    filename=[mfilename(1) '-eta-' num2str(dt)];
                    plot(dt*(0:npts-1), etas(1:npts), [colors(4) line], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), etas(markers), [colors(4) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                otherwise
            end

            %pause(2.5);

            disp(['||R-converged R|| = ' num2str(norm(R-converged_R_at_20))]);
            nRs=[nRs norm(R-converged_R_at_20)];
            disp(['||Omega-converged Omega|| = ' num2str(norm(Omegas(:,end)-converged_Omega_at_20))]);
            nmbfs=[nmbfs norm(I*Omegas(:,end)-I*converged_Omega_at_20)];
            anRs.dts=dts;
            anRs.(class(ri))={nRs};
            anmbfs.dts=dts;
            anmbfs.(class(ri))={nmbfs};
            figure(gcf); drawnow;
        end
        %         for suffix={'fig' 'png' 'eps2'}
        %             suf=suffix{1};
        %             saveas(gcf, [filename '.' suf(1:3)], suf);
        %         end
        %saveas(gcf, filename, 'png'); % eps2
    end
end
echo off