disp(' ');
disp('Slow Lagrangian top');
cd(fealab_work_path);
[fens,gcells] = bigone;
feb = feblock_ss (mater_ss_linelastic (1,0), gcells, 2);
geom = rotate(translate(field('geom', 3, fens),[0 0 6]),rotmat([0 0 pi])); 
u = 0*geom;
nRs=[];nmbfs=[];nmsps=[];
nmarkers=10; nadv=1; histoff=0;
% clf;
dts=[1/8 1/16 1/32 1/64 1/128 1/256 1/512 ];
% dts=[0.2];
marker_type='oxd*sdv^<>ph';
colors='rbgcykm';
graphics=0;
tend=20;
setnum=0;
for plotwhat={'13'}
   kc=1;
   for choose_integrator={
          'cardona_geradin'  'simo_wong_algo_c1' 'akw' 'imid' 'mid_lie_impl' 'trapez' 'trapez_int'
        }
        kc=kc+1;
        ri=get_rotint(choose_integrator);
        nRs=[];
        nmbfs=[];
        nmsps=[];
        for dt=dts;
            % Data, Initial conditions
            torque = inline('-skewmat(R(:,3))*[0;0;1]*20','t', 'R');
            % Data, Initial conditions
            I=[5 0 0; 0 5 0; 0 0 1];
            R = rotmat([0.05 0 0]);
            omega = R*[0 0 5]';
            exactkinenergy=omega'*R*I*R'*omega/2;
            exacthamilt=exactkinenergy+R(:,3)'*[0;0;1]*20;
            Omega=R'*omega;
            converged_R_at_20 = [
                -1.322160948371581e-001   -9.911525719838213e-001   -1.163973005990285e-002
    9.858393579154383e-001   -1.302672123901182e-001   -1.055993075781468e-001
    1.031487501179139e-001   -2.543683207405415e-002    9.943406372683098e-001
            ];
            converged_Omega_at_20 = [
                8.415781079386203e-002
    1.679120248050994e-001
    5.000000000562824e+000
            ];
            
            line='-';
            % Choose integrator
            ri = set(ri, 'I', I);
            ri = set(ri, 'R', R);
            ri = set(ri, 'omega', omega);
            
            limits=[-5 5 -5 5 -5 5];
            nsteps=round(tend/dt);
            reportat=nsteps/nadv/20;
            if (histoff)
                nsnapshots=100;
            else
                nsnapshots=nsteps+1;
            end
            omegas=zeros(3,nsnapshots);
            momenta=zeros(3,nsnapshots);
            kinenergy=zeros(1,nsnapshots);
            potenergy=zeros(1,nsnapshots);
            Omegas=zeros(3,nsnapshots);
            vectup=zeros(3,nsnapshots);
            incrrotvect=zeros(3,nsnapshots);
            rotvect=zeros(3,nsnapshots);
            incrrotvectmag=zeros(1,nsnapshots);
            proj_on_gravity=zeros(1,nsnapshots);
            proj_on_topaxis=zeros(1,nsnapshots);
            if graphics
                clf;
                gm1=graphics_model(make_graphics_reps(feb, geom, 0*geom, 'gcells'));
                draw(gm1, 'limits', limits, 'dataidx', 3, 'scale', 0.2000, 'displace_by', [1 2 3], 'facecolor', 'none')
            end
            tic;
            ri = set(ri, 't', 0);
            % store history for t=0
            snapshot=1;
            omega=get(ri, 'omega');
            R1=R;
            R=get(ri, 'R');
            V=rotmat2rotvec((R1')*R);
            incrrotvect(:,snapshot)=V;
            incrrotvectmag(:,snapshot)=norm(V)*180/pi;
            rotvect(:,snapshot)=rotmat2rotvec(R);
            omegas(:,snapshot)=omega;
            Omegas(:,snapshot)=R'*omega;
            L=R*I*R'*omega;
            momenta(:,snapshot)=L;
            kinenergy(snapshot)= 1/2*omega'*L;
            potenergy(snapshot)= +R(:,3)'*[0;0;1]*20;
            vectup(:,snapshot)=R(:,3);
            proj_on_gravity(snapshot)=L'*[0;0;1];
            proj_on_topaxis(snapshot)=L'*vectup(:,snapshot);
            for i=1:ceil(nsteps/nadv)
                % advance by one step
                ri = advance(ri, torque,dt,nadv);
                % save history
                if (histoff)
                    snapshot=2;
                else
                    snapshot=snapshot+1;
                end
                omega=get(ri, 'omega');
                R1=R;
                R=get(ri, 'R');
                V=rotmat2rotvec((R1')*R);
                incrrotvect(:,snapshot)=V;
                incrrotvectmag(:,snapshot)=norm(V)*180/pi;
                rotvect(:,snapshot)=rotmat2rotvec(R);
                omegas(:,snapshot)=omega;
                Omegas(:,snapshot)=R'*omega;
                L=R*I*R'*omega;
                momenta(:,snapshot)=L;
                kinenergy(snapshot)= 1/2*omega'*L;
                potenergy(snapshot)= +R(:,3)'*[0;0;1]*20;
                vectup(:,snapshot)=R(:,3);
                proj_on_gravity(snapshot)=L'*[0;0;1];
                proj_on_topaxis(snapshot)=L'*vectup(:,snapshot);
                % graphics
                if graphics
                    currgeom=rotate(geom, R);
                    u=currgeom-geom;
                    clf;
                    draw(gm1, 'limits', limits, 'dataidx', 3, 'scale', 0.2000, 'displace_by', [1 2 3], 'facecolor', 'none')
                    gm2=graphics_model(make_graphics_reps(feb, geom, u, 'gcells'));
                    draw(gm2, 'limits', limits, 'dataidx', 1, 'scale', 1, 'displace_by', [1 2 3], 'facecolor', 'interp')
                    pause(0.005); % next eigenvector
                end
                if (round(i/(reportat))*reportat == i)
                    disp([num2str(nadv*i) ' steps of ' num2str(nsteps) ' (' num2str(toc) ' sec)']);
                end
            end
            disp(['Reached time ' num2str(get(ri,'t'))]);
            toc
            
            if (graphics)
                plotwhat={'nothing'};
            end
            hold on
            npts=size(momenta,2);
            setnum=setnum+1;
            set(gca,'LineWidth',2);
            set(gca,'FontSize',16);
            set(gca,'TickLength',[0.025 0.06]);  % default values are: 0.0100 0.0250
            set(gca,'XGrid','on');
            set(gca,'YGrid','on');
            xlabel('Time');
            plotwhat1=plotwhat{1};
            if (~strcmp(class(plotwhat{1}),'char'))
                plotwhat1=num2str(plotwhat{1});
            end
            switch plotwhat1
                case {'0' 'kin'}
                    ylabel('Kinetic energy');
                    filename=[mfilename(1) '-kin-' num2str(dt)];
                    plot(dt*(0:npts-1), kinenergy(1:npts), [colors(4) line], 'LineWidth', 1.5);                
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), kinenergy(markers), [colors(4) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);                
                case '1'
                    ylabel('Normalized Kinetic energy');
                    filename=[mfilename '-normkin-' num2str(dt)];
                    plot(dt*(0:npts-1), (kinenergy(1:npts)-exactkinenergy)/exactkinenergy, [colors(4) line], 'LineWidth', 1.5);
                    plot(dt*(markers-1), (kinenergy(markers)-exactkinenergy)/exactkinenergy, [colors(4) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                case {'2' 'bfOmega'}
                    ylabel('Angular velocity/body frame');                    
                    filename=[mfilename '-bfOmega-' num2str(dt)];
                    plot(dt*(0:npts-1), Omegas(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Omegas(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Omegas(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\Omega_1', '\Omega_2', '\Omega_3');
                case {'3' 'omega'}
                    ylabel('Angular velocity/spatial frame'); 
                    filename=[mfilename '-omega-' num2str(dt)];
                    plot(dt*(0:npts-1), omegas(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), omegas(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), omegas(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\omega_1', '\omega_2', '\omega_3');
                case {'4' 'mom' 'pi'}
                    ylabel('Spatial angular momenta'); 
                    filename=[mfilename '-mom-' num2str(dt)];
                    plot(dt*(0:npts-1), momenta(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), momenta(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), momenta(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\pi_1', '\pi_2', '\pi_3');
                case {'5' 'vectup'}
                    ylabel('y-component of vector-up'); 
                    xlabel('x-component of vector-up'); 
                    filename=[mfilename '-vectup-' num2str(dt)];
                    hold on
                    axis square
                    plot(vectup(1,:), vectup(2,:), colors(mod(kc,3)+1),  'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(vectup(1,markers), vectup(2,markers), [colors(mod(kc,3)+1)  marker_type(mod(setnum,length(marker_type))+1)],  'LineWidth', 1.5);
                case {'6' 'incrrotvec' 'incrvec'}
                    ylabel('Incremental rotation vector'); 
                    filename=[mfilename '-incrrotvec-' num2str(dt)];
                    plot(dt*(0:npts-1), incrrotvect(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), incrrotvect(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), incrrotvect(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\Delta\Theta_1', '\Delta\Theta_2', '\Delta\Theta_3');
                case {'7' 'incrrotvecmag'}
                    ylabel('Magnitude of incremental rotation vector'); 
                    filename=[mfilename '-incrrotvecmag-' num2str(dt)];
                    plot(dt*(0:npts-1), incrrotvectmag(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvectmag(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                case '8'
                    ylabel('Rotation vector'); 
                    filename=[mfilename '-rotvec-' num2str(dt)];
                    plot(dt*(0:npts-1), rotvect(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), rotvect(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), rotvect(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(1,markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(2,markers), [colors(2) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(3,markers), [colors(3) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\Theta_1', '\Theta_2', '\Theta_3');
                case '9'
                    view(3);
                    axis equal vis3d;
                    sphereplot(dt*(0:npts-1), vectup, 'init');
                    for i=1:npts
                        sphereplot([dt*(i-1)], vectup(:,i));
                    end
                    sphereplot([],[],'done');
                case '10'
                    ex_proj=proj_on_gravity(1,1);
                    ylabel('\pi*g'); 
                    filename=[mfilename '-projgrav-' num2str(dt)];
                    plot(dt*(0:npts-1), proj_on_gravity(1,:)-ex_proj, [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), proj_on_gravity(1,markers)-ex_proj, [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\pi*g');
                case '11'
                    ex_proj=proj_on_topaxis(1,1);
                    ylabel('\pi*\chi'); 
                    filename=[mfilename '-projtop-' num2str(dt)];
                    plot(dt*(0:npts-1), proj_on_topaxis(1,:)-ex_proj, [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), proj_on_topaxis(1,markers)-ex_proj, [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('\pi*\chi');
                case {'13' 'hamilt'}
                    ylabel('Hamiltonian'); 
                    filename=[mfilename '-hamilt-' num2str(dt)];
                    plot(dt*(0:npts-1), (kinenergy+potenergy), [colors(mod(setnum,length(colors))+1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), (kinenergy(markers)+potenergy(markers)), [colors(mod(setnum,length(colors))+1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('Hamiltonian');
                case {'14' 'nmom'}
                    ylabel('Norm of spatial angular momenta'); 
                    filename=[mfilename '-nmom-' num2str(dt)];
                    nm=sqrt(momenta(1,:).*momenta(1,:)+momenta(2,:).*momenta(2,:)+momenta(3,:).*momenta(3,:));
                    plot(dt*(0:npts-1), nm, [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), nm(markers), [colors(1) marker_type(mod(setnum,length(marker_type))+1)], 'LineWidth', 1.5);
                    legend('||\pi||');
                case {'15' 'bfmomsphplt'}
                    view(3);
                    axis equal vis3d;
                    filename=[mfilename '-bfmomsphplt-' num2str(dt)];
                    sphereplot(dt*(0:npts-1), I*Omegas(:,1)/norm(exact_spm), 'init');
                    for i=1:npts
                        sphereplot([dt*(i-1)], I*Omegas(:,i)/norm(exact_spm));
                    end
                    sphereplot([],[],'done');
                    xlabel('\Pi_1');
                    ylabel('\Pi_2');
                    zlabel('\Pi_3');
                case 'nothing'
                otherwise
                    error('Unknown plot type');
            end
            
            %pause(2.5);
            disp(['||R-converged R|| = ' num2str(norm(R-converged_R_at_20))]);
            nRs=[nRs norm(R-converged_R_at_20)];
            disp(['||Omega-converged Omega|| = ' num2str(norm(Omegas(:,end)-converged_Omega_at_20))]);
            nmbfs=[nmbfs norm(I*Omegas(:,end)-I*converged_Omega_at_20)];
            anRs.dts=dts;
            anRs.(class(ri))={nRs};
            anmbfs.dts=dts;
            anmbfs.(class(ri))={nmbfs};
            save([mfilename(1) '-' datestr(now,30) '-anRs.mat'], 'anRs');
            save([mfilename(1) '-' datestr(now,30) '-anmbfs.mat'], 'anmbfs');
        end
        for suffix={'fig' 'png' 'eps2'}
            suf=suffix{1};
            saveas(gcf, [filename '.' suf(1:3)], suf); 
        end
        
        
        
        %saveas(gcf, filename, 'png'); % eps2
        %         disp(['||R-converged R|| = ' num2str(norm(R-converged_R_at_100))]);
        %         nRs=[nRs norm(R-converged_R_at_100)];
        %         disp(['||Omega-converged Omega|| = ' num2str(norm(Omegas(:,end)-converged_Omega_at_100))]);
        %         nms=[nms norm(I*Omegas(:,end)-I*converged_Omega_at_100)];
    end
end
echo off