E=200000;% Young's modulus
nu=0.28;% Poisson ratio
rho=7.800e-9;% mass density
OmegaShift=(2*pi*4) ^ 2;
W=2000;
H=50;
L =3000;
nL=30; nW=30; nH =8;
graphics = false;

% Mesh
[fens,gcells]= H8_block(L, W, H, nL, nW, nH);
% drawmesh({fens,gcells},'gcells','facecolor','red','shrink',0.85)
% Material
prop = property_linel_iso (struct('E',E,'nu',nu,'rho',rho));
mater = mater_defor_ss_linel_triax (struct('property',prop));
% Finite element block
feb = feblock_defor_ss (struct ('mater',mater, 'gcells',gcells,...
    'integration_rule',gauss_rule(3,2)));
% Geometry
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
limits =reshape([min(get(geom,'values'));max(get(geom,'values'))], 6, 1);
% Define the displacement field
u   = 0*geom; % zero out
% No EBC's: free-floating
u   = apply_ebc (u);
% Number equations
u   = numbereqns (u);

% Assemble the system matrix
disp(['Stiffness ' num2str(get(u, 'neqns')) 'x' num2str(get(u, 'neqns')) ' assembly']);
K = start (sparse_sysmat, get(u, 'neqns'));
evs=stiffness(feb, geom, u);
tic
% K = assembleOriginal (K, evs);%
K = assemble (K, evs);%
toc